function XPN.CreateXPWindow()
	if (XPNWindow == nil) then	
		XPN_Window = WINDOW_MANAGER:CreateTopLevelWindow("XPNWindow")
		XPN_Window:SetMouseEnabled(true)
		XPN.ShowWindowPerSettings()
		XPN_Window:SetMovable(true)
		XPN_Window:SetDimensions(XPN.SavedData.Window.Width, XPN.SavedData.Window.Height)
		XPN_Window:SetResizeHandleSize(8)
		XPN_Window:SetAnchor(TOPLEFT, GuiRoot, TOPLEFT, XPN.SavedData.Window.X, XPN.SavedData.Window.Y)
		
		XPNWindow:SetHandler("OnMouseExit",  function() XPN.WindowMouseExit(XPNWindow) end)
		XPNWindow:SetHandler("OnMouseEnter", function() XPN.WindowShowFaded() end)
		XPNWindow:SetHandler("OnMouseDown",  function() XPN.WindowShowResizeBox() end)
		XPNWindow:SetHandler("OnMouseUP",    function() XPN.WindowHideResizeBox() end)
		XPNWindow:SetHandler("OnMouseWheel", function(self, delta) XPNWindowBuffer:MoveScrollPosition(delta) end)
		
		XPN_Window_BG = WINDOW_MANAGER:CreateControl("XPNWindowBG", XPNWindow, CT_BACKDROP)
		XPN.WindowBackgroundFadePerSettings()
		XPN_Window_BG:SetCenterColor(0, 0, 0, 0.5)
		XPN_Window_BG:SetEdgeColor(0.1, 0.1, 0.1, 1.0)
		XPN_Window_BG:SetEdgeTexture("", 8, 1, 2)
		XPN_Window_BG:SetAnchorFill(XPNWindow)
		
		XPN_WindowResize_BG = WINDOW_MANAGER:CreateControl("XPNResizeBG", XPNWindow, CT_BACKDROP)
		XPN_WindowResize_BG:SetHidden(true)
		XPN_WindowResize_BG:SetEdgeColor(0.1, 0.1, 0.1, 1.0)
		XPN_WindowResize_BG:SetCenterColor(0, 0, 0, 0.5)
		XPN_WindowResize_BG:SetEdgeTexture("", 8, 1, 2)
		XPN_WindowResize_BG:SetAnchorFill(XPNWindow)

		XPN_WindowBuffer = WINDOW_MANAGER:CreateControl("XPNWindowBuffer", XPN_Window, CT_TEXTBUFFER)
 		XPN_WindowBuffer:SetLinkEnabled(true)
 		XPN_WindowBuffer:SetFont("ZoFontChat")
 		XPN_WindowBuffer:SetHidden(false)
		XPN_WindowBuffer:SetClearBufferAfterFadeout(true)
 		XPN.FadeWindowSettingUpdate()
 		XPN_WindowBuffer:SetMaxHistoryLines(100)
		XPN_WindowBuffer:SetAnchorFill(XPN_Window)
	else
		XPN.ShowWindowPerSettings()
	end
end


function XPN.InterfaceUpdate()
	if (XPNWindow == nil) then return end -- we'll get updates before the window is created, so just ignore 'em

	local bIsUIHidden = ZO_Compass:IsHidden() -- cheap, but we use the in-game compass visibility state to figure out if the user is in settings/menus or not
	
	if (bIsUIHidden and XPN.SavedData.Window.HideInMenus) then
		XPN.HideWindow()
	else
		XPN.ShowWindowPerSettings()
	end
end


function XPN.FadeWindowSettingUpdate()
	XPN_WindowBuffer:SetLineFade(XPN.SavedData.FadeTimer, 3)
end


function XPN.Message(message)
	if (XPN.SavedData.Window.UseMode ~= 0) then XPNWindowBuffer:AddMessage(message) end
	if (XPN.SavedData.Window.UseMode ~= 1) then d(message) end
end


function XPN.ShowWindowPerSettings()
	XPN_Window:SetHidden(XPN.SavedData.Window.UseMode == 0)
end


function XPN.WindowBackgroundFadePerSettings()
	XPNWindowBG:SetHidden(XPN.SavedData.Window.BackgroundFade)
end


function XPN.ShowWindow()
	XPN_Window:SetHidden(false)
end


function XPN.HideWindow()
	XPN_Window:SetHidden(true)
end


function XPN.WindowMouseExit(window)
	XPN.SavedData.Window.X = window:GetLeft()
	XPN.SavedData.Window.Y = window:GetTop()
	XPN.WindowBackgroundFadePerSettings()
	XPNWindowBuffer:SetScrollPosition(0)
end


function XPN.WindowShowFaded()
	XPNWindowBG:SetHidden(false)
	XPNWindowBuffer:ShowFadedLines()	
end


function XPN.WindowShowResizeBox()
	XPNResizeBG:SetHidden(false)
end


function XPN.WindowHideResizeBox()
	XPN.SavedData.Window.Width, XPN.SavedData.Window.Height = XPNWindow:GetDimensions()
	XPNResizeBG:SetHidden(true)
end
