function XPN.Lang.Init()
	XPN.Lang.Localization = { }

	if (XPN.Lang.CurrentLanguage() == "English") then
	
		XPN.Lang.Localization.NowLoadedFor = " now loaded for |r"
		XPN.Lang.Localization.RepeatToLevelA = "repeat |r"
		XPN.Lang.Localization.RepeatToLevelB = " times to level"
		XPN.Lang.Localization.Level = "Level"
		XPN.Lang.Localization.NewLevel = "new level: "
		XPN.Lang.Localization.NewLevelVP = "new veteran level: "
		XPN.Lang.Localization.NewLevelTS = "new tradeskill level: "
		XPN.Lang.Localization.NewLevelSkill = "new skill level: "
		XPN.Lang.Localization.ReloadUIForNewSkill = "You have learned a new skill line.  Please reload your UI to see it in the settings panel."
		XPN.Lang.Localization.Veteran = "Veteran"
		
	elseif (XPN.Lang.CurrentLanguage() == "French") then
	
		XPN.Lang.Localization.NowLoadedFor = " chargé pour |r"
		XPN.Lang.Localization.RepeatToLevelA = "répéter |r"
		XPN.Lang.Localization.RepeatToLevelB = " fois à niveau"
		XPN.Lang.Localization.Level = "Niveau"
		XPN.Lang.Localization.NewLevel = "nouveau niveau: "
		XPN.Lang.Localization.NewLevelVP = "nouveau niveau vétéran: "
		XPN.Lang.Localization.NewLevelTS = "nouveau niveau d'artisanat: "
		XPN.Lang.Localization.NewLevelSkill = "nouveau niveau de compétence: "
		XPN.Lang.Localization.ReloadUIForNewSkill = "Vous avez appris un nouveau type de compétences.  Veuillez recharger votre interface pour le voir dans le panneau des paramètres."
		XPN.Lang.Localization.Veteran = "Vétéran"
		
	elseif (XPN.Lang.CurrentLanguage() == "German") then
	
		XPN.Lang.Localization.NowLoadedFor = " geladen für |r"
		XPN.Lang.Localization.RepeatToLevelA = "wiederhole |r"
		XPN.Lang.Localization.RepeatToLevelB = " mal um zu leveln"
		XPN.Lang.Localization.Level = "Level"
		XPN.Lang.Localization.NewLevel = "neues Level: "
		XPN.Lang.Localization.NewLevelVP = "neues Veteranen-Level: "
		XPN.Lang.Localization.NewLevelTS = "neues Handwerk-Level: "
		XPN.Lang.Localization.NewLevelSkill = "neues Fähigkeiten-Level: "
		XPN.Lang.Localization.ReloadUIForNewSkill = "Sie haben eine neue Fertigkeiten-Linie erlernt. Laden Sie Ihr Interface neu, um es in den Einstellungen zu sehen."
		XPN.Lang.Localization.Veteran = "Veteran"
		
	end	
	
end


function XPN.Lang.CurrentLanguage()
	if XPN.Lang.Localization == nil then XPN.Lang.Init() end
	
	if XPN.SavedData.Language == "de" then return "German" end
	if XPN.SavedData.Language == "fr" then return "French" end
	
	return "English"
end
