--*
--*  Utility functions by Peter Souza IV (@Azilarir)
--*


function PrettyNumberFormatter(num)
	local temp = tostring(tonumber(num))
	temp = string.gsub(temp, "(%d)(%d%d%d)$", "%1,%2", 1)
	while true do
		temp, found = string.gsub(temp, "(%d)(%d%d%d),", "%1,%2,", 1)
		if found == 0 then break end
	end
	
	if (XPN) then
		if (XPN.Lang) then
			if (XPN.Lang.CurrentLanguage() == "French") then temp = string.gsub(temp, ",", " ") end
			if (XPN.Lang.CurrentLanguage() == "German") then temp = string.gsub(temp, ",", ".") end
		end
	end
	
	return temp
end


function HexDigit(num)
	temp = string.format("%02X", tonumber(num))
	if (temp:len() == 1) then return "0" .. temp end
	if (temp:len() == 2) then return temp end
	return temp:sub(1, 2)
end


function ConvertColorToHex(color)
	return HexDigit(color.r * 255) .. HexDigit(color.g * 255) .. HexDigit(color.b * 255)
end


--*  Much better approach than #Table
function TableLength(T)
	local count = 0
	for _ in pairs(T) do count = count + 1 end
	return count
end


function string.endsWith(String, End)
	return End == '' or string.sub(String, -string.len(End)) == End
end


function CleanName(s)
	s = tostring(s)
	
	if (string.endsWith(s, "^m")) then return string.sub(s, 1, string.len(s) - 2) end
	if (string.endsWith(s, "^m")) then return string.sub(s, 1, string.len(s) - 2) end
	if (string.endsWith(s, "^M")) then return string.sub(s, 1, string.len(s) - 2) end
	if (string.endsWith(s, "^n")) then return string.sub(s, 1, string.len(s) - 2) end
	if (string.endsWith(s, "^p")) then return string.sub(s, 1, string.len(s) - 2) end
	if (string.endsWith(s, "^N")) then return string.sub(s, 1, string.len(s) - 2) end
	if (string.endsWith(s, "^f")) then return string.sub(s, 1, string.len(s) - 2) end
	if (string.endsWith(s, "^F")) then return string.sub(s, 1, string.len(s) - 2) end
	if (string.endsWith(s, "^fd")) then return string.sub(s, 1, string.len(s) - 3) end
	if (string.endsWith(s, "^pd")) then return string.sub(s, 1, string.len(s) - 3) end
	if (string.endsWith(s, "^pf")) then return string.sub(s, 1, string.len(s) - 3) end

	return s
end
